[tox]
minversion = 3.1.1
envlist = py39,py38,pep8
skipsdist = True
ignore_basepython_conflict = True

[testenv]
basepython = python3
setenv = VIRTUAL_ENV={envdir}
usedevelop = True
deps =
   -c{env:UPPER_CONSTRAINTS_FILE:https://opendev.org/openstack/requirements/raw/branch/master/upper-constraints.txt}
   -r{toxinidir}/requirements.txt
   -r{toxinidir}/test-requirements.txt
passenv = OS_TEST_*
commands = stestr run --slowest {posargs}

[testenv:docs]
deps =
   -c{env:UPPER_CONSTRAINTS_FILE:https://opendev.org/openstack/requirements/raw/branch/master/upper-constraints.txt}
   -r{toxinidir}/doc/requirements.txt
commands = sphinx-build -W -b html doc/source doc/build/html

[testenv:releasenotes]
deps =
   -c{env:UPPER_CONSTRAINTS_FILE:https://opendev.org/openstack/requirements/raw/branch/master/upper-constraints.txt}
   -r{toxinidir}/doc/requirements.txt
commands = sphinx-build -a -E -W -d releasenotes/build/.doctrees -b html releasenotes/source releasenotes/build/html

[testenv:pep8]
commands =
  flake8 {posargs}
  doc8 {posargs}

[testenv:cover]
setenv =
    PYTHON=coverage run --source glance_store --parallel-mode
commands =
    stestr run {posargs}
    coverage combine
    coverage html -d cover
    coverage xml -o cover/coverage.xml

[testenv:venv]
commands = {posargs}

# See glance_store/tests/functional/README.rst for information on writing or
# running functional tests.
[testenv:functional-swift]
sitepackages = True
commands =
    stestr run --slowest --test-path=./glance_store/tests/functional/swift

[testenv:functional-filesystem]
commands =
    stestr run --slowest --test-path=./glance_store/tests/functional/filesystem

[doc8]
ignore-path = .venv,.git,.tox,*glance_store/locale*,*lib/python*,glance_store.egg*,doc/build,*requirements.txt

[flake8]
# TODO(dmllr): Analyze or fix the warnings blacklisted below
# H301  one import per line
# H404  multi line docstring should start with a summary
# H405  multi line docstring summary not separated with an empty line
# W503 line break before binary operator
# W504 line break after binary operator
ignore = H301,H404,H405,W503,W504
exclude = .venv,.git,.tox,dist,doc,etc,*glance_store/locale*,*lib/python*,*egg,build

